//#include "cube.h"

int pattern[15][8]={
	{ 0, 0, 0, 0, 0, 0, 0, 0 },//0
	{ 0, 0, 0, 0, 1, 0, 0, 0 },//1 [4]
	{ 0, 0, 0, 0, 1, 1, 0, 0 },//2 [4][5]
	{ 0, 1, 0, 0, 1, 0, 0, 0 },//2 [4][1]
	{ 0, 0, 1, 0, 1, 0, 0, 0 },//2 [4][2]
	{ 1, 0, 0, 0, 1, 1, 0, 0 },//3 [4][0][5]
	{ 0, 0, 1, 0, 1, 1, 0, 0 },//3 [4][5][2]
	{ 0, 1, 0, 0, 1, 0, 1, 0 },//3 [4][1][6]
	{ 0, 0, 0, 0, 1, 1, 1, 1 },//4 [4][5][6][7]
	{ 1, 0, 0, 0, 1, 1, 0, 1 },//4 [4][5][7][0]
	{ 1, 0, 1, 0, 1, 0, 1, 0 },//4 [4][0][6][2]
	{ 0, 1, 1, 0, 1, 1, 0, 0 },//4 [4][5][1][2]
	{ 0, 1, 1, 1, 1, 0, 0, 0 },//4 [4][3][1][2]
	{ 0, 1, 0, 1, 1, 0, 1, 0 },//4 [4][6][1][3]
	{ 1, 1, 1, 0, 1, 0, 0, 0 } //4 [4][0][1][2]
};

int rotationYC(int number){
		return (number+1)%4+(number/4)*4;
}

int rotationXC(int number){
	switch(number){
		case 0:
			number=4;
			break;
		case 1:
			number=5;
			break;
		case 2:
			number=1;
			break;
		case 3:
			number=0;
			break;
		case 4:
			number=7;
			break;
		case 5:
			number=6;
			break;
		case 6:
			number=2;
			break;
		case 7:
			number=3;
			break;
	}
	return number;
}

int rotationZC(int number){
	switch(number){
		case 0:
			number=4;
			break;
		case 1:
			number=0;
			break;
		case 2:
			number=3;
			break;
		case 3:
			number=7;
			break;
		case 4:
			number=5;
			break;
		case 5:
			number=1;
			break;
		case 6:
			number=2;
			break;
		case 7:
			number=6;
			break;
	}
	return number;
}

void rotationY(int *data, ogVector *sv, int *d){
	ogVector damyv;
	int damyd;

	for(int i=0;data[i]!=-1;i++){
//		data[i]=(data[i]+1)%4+(data[i]/4)*4;
		data[i]=rotationYC(data[i]);
	}

/*	for(int j=0;j<8;j+=4){
		damyv=sv[j+3];
		damyd=d[j+3];
		for(i=j;i<j+3;i++){
			sv[rotationYC(i)]=sv[i];
			d[rotationYC(i)]=d[i];
		}
		sv[j]=damyv;
		d[j]=damyd;
	}
	*/
	damyv=sv[0];
	sv[0]=sv[3];
	sv[3]=sv[2];
	sv[2]=sv[1];
	sv[1]=damyv;
	damyv=sv[4];
	sv[4]=sv[7];
	sv[7]=sv[6];
	sv[6]=sv[5];
	sv[5]=damyv;

	damyd=d[0];
	d[0]=d[3];
	d[3]=d[2];
	d[2]=d[1];
	d[1]=damyd;
	damyd=d[4];
	d[4]=d[7];
	d[7]=d[6];
	d[6]=d[5];
	d[5]=damyd;

}



void rotationX(int *data, ogVector *sv, int *d){
	ogVector damyv;
	int damyd;
//	int j,k;

/*	damyv[0]=sv[0];
	damyd[0]=d[0];
	damyv[1]=sv[1];
	damyd[1]=d[1];
*/
	for(int i=0;data[i]!=-1;i++){
		data[i]=rotationXC(data[i]);
	}
/*
	k=3; j=2;
	for(i=0;i<3;i++){
		sv[rotationXC(k)]=sv[k];
		d[rotationXC(k)]=d[k];
		sv[rotationXC(j)]=sv[j];
		d[rotationXC(j)]=d[j];
		k=rotationXC(k);
		j=rotationXC(j);
	}

	sv[4]=damyv[0];
	d[4]=damyd[0];
	sv[5]=damyv[1];
	d[5]=damyd[1];
*/

	damyv=sv[0];
	sv[0]=sv[3];
	sv[3]=sv[7];
	sv[7]=sv[4];
	sv[4]=damyv;
	damyv=sv[1];
	sv[1]=sv[2];
	sv[2]=sv[6];
	sv[6]=sv[5];
	sv[5]=damyv;

	damyd=d[0];
	d[0]=d[3];
	d[3]=d[7];
	d[7]=d[4];
	d[4]=damyd;
	damyd=d[1];
	d[1]=d[2];
	d[2]=d[6];
	d[6]=d[5];
	d[5]=damyd;

}

void rotationZ(int *data,ogVector *sv, int *d){
	ogVector damyv;
	int damyd;

	for(int i=0;data[i]!=-1;i++){
		data[i]=rotationZC(data[i]);
	}

	damyv=sv[0];
	sv[0]=sv[1];
	sv[1]=sv[5];
	sv[5]=sv[4];
	sv[4]=damyv;
	damyv=sv[3];
	sv[3]=sv[2];
	sv[2]=sv[6];
	sv[6]=sv[7];
	sv[7]=damyv;

	damyd=d[0];
	d[0]=d[1];
	d[1]=d[5];
	d[5]=d[4];
	d[4]=damyd;
	damyd=d[3];
	d[3]=d[2];
	d[2]=d[6];
	d[6]=d[7];
	d[7]=damyd;
}

int checkM2(int *data,int *i,ogVector *sv, int *d){
	int c;
//	int jk;
//	printf("(d%d,",data[0]);
//	jk=i[0];
//	if(jk==90){printf("\n");for(int p=0;p<8;p++)printf("(%d,(%d)(%d,%d))",p,d[p],data[0],data[1]);}
	c=0;
	for(int k=0;k<2;k++){if(pattern[2][data[k]]==1)c++;}
	if(c==2){/*printf("%d)",data[0]);*/return 2;}
	c=0;
	for(int k=0;k<2;k++){if(pattern[3][data[k]]==1)c++;}
	if(c==2)return 3;
	c=0;
	for(int k=0;k<2;k++){if(pattern[4][data[k]]==1)c++;}
	if(c==2)return 4;

	for(i[0]=0;i[0]<4;i[0]++){
		for(i[1]=0;i[1]<3;i[1]++){
			rotationY(data,sv,d);
//	if(jk==90){printf("\n");for(int p=0;p<8;p++)printf("(%d,(%d)(%d,%d))",p,d[p],data[0],data[1]);}
			c=0;
			for(int k=0;k<2;k++){if(pattern[2][data[k]]==1)c++;}
			if(c==2){/*printf("%d)",data[0]);*/return 2;}
			c=0;
			for(int k=0;k<2;k++){if(pattern[3][data[k]]==1)c++;}
			if(c==2)return 3;
			c=0;
			for(int k=0;k<2;k++){if(pattern[4][data[k]]==1)c++;}
			if(c==2)return 4;
		}
		rotationY(data,sv,d);
//	if(jk==90){printf("\n");for(int p=0;p<8;p++)printf("(%d,(%d)(%d,%d))",p,d[p],data[0],data[1]);}
		rotationX(data,sv,d);
//	if(jk==90){printf("\n");for(int p=0;p<8;p++)printf("(%d,(%d)(%d,%d))",p,d[p],data[0],data[1]);}
		c=0;
		for(int k=0;k<2;k++){if(pattern[2][data[k]]==1)c++;}
		if(c==2){/*printf("%d)",data[0]);*/return 2;}
		c=0;
		for(int k=0;k<2;k++){if(pattern[3][data[k]]==1)c++;}
		if(c==2)return 3;
		c=0;
		for(int k=0;k<2;k++){if(pattern[4][data[k]]==1)c++;}
		if(c==2)return 4;
	}
//	printf("(%d,",data[0]);
//	rotationX(data);
//	printf(" %d)",data[0]);
	return -1;
}

int checkM3(int *data,int *i,ogVector *sv, int *d){
	int c;

	c=0;
	for(int k=0;k<3;k++){if(pattern[5][data[k]]==1)c++;}
	if(c==3){return 5;}
	c=0;
	for(int k=0;k<3;k++){if(pattern[6][data[k]]==1)c++;}
	if(c==3)return 6;
	c=0;
	for(int k=0;k<3;k++){if(pattern[7][data[k]]==1)c++;}
	if(c==3)return 7;

	for(i[0]=0;i[0]<4;i[0]++){
		for(i[1]=0;i[1]<3;i[1]++){
			rotationY(data,sv,d);
			c=0;
			for(int k=0;k<3;k++){if(pattern[5][data[k]]==1)c++;}
			if(c==3){return 5;}
			c=0;
			for(int k=0;k<3;k++){if(pattern[6][data[k]]==1)c++;}
			if(c==3)return 6;
			c=0;
			for(int k=0;k<3;k++){if(pattern[7][data[k]]==1)c++;}
			if(c==3)return 7;
		}
		rotationY(data,sv,d);
		rotationX(data,sv,d);
		c=0;
		for(int k=0;k<3;k++){if(pattern[5][data[k]]==1)c++;}
		if(c==3){return 5;}
		c=0;
		for(int k=0;k<3;k++){if(pattern[6][data[k]]==1)c++;}
		if(c==3)return 6;
		c=0;
		for(int k=0;k<3;k++){if(pattern[7][data[k]]==1)c++;}
		if(c==3)return 7;
		}
	return -1;
}

int checkM4(int *data,int *i,ogVector *sv, int *d){
	int c;

	c=0;
	for(int k=0;k<4;k++){if(pattern[8][data[k]]==1)c++;}
	if(c==4)return 8;
	c=0;
	for(int k=0;k<4;k++){if(pattern[9][data[k]]==1)c++;}
	if(c==4)return 9;
	c=0;
	for(int k=0;k<4;k++){if(pattern[10][data[k]]==1)c++;}
	if(c==4)return 10;
	c=0;
	for(int k=0;k<4;k++){if(pattern[11][data[k]]==1)c++;}
	if(c==4)return 11;
	c=0;
	for(int k=0;k<4;k++){if(pattern[12][data[k]]==1)c++;}
	if(c==4)return 12;
	c=0;
	for(int k=0;k<4;k++){if(pattern[13][data[k]]==1)c++;}
	if(c==4)return 13;
	c=0;
	for(int k=0;k<4;k++){if(pattern[14][data[k]]==1)c++;}
	if(c==4)return 14;

	for(i[0]=0;i[0]<4;i[0]++){
		for(i[1]=0;i[1]<3;i[1]++){
			rotationY(data,sv,d);
			c=0;
			for(int k=0;k<4;k++){if(pattern[8][data[k]]==1)c++;}
			if(c==4)return 8;
			c=0;
			for(int k=0;k<4;k++){if(pattern[9][data[k]]==1)c++;}
			if(c==4)return 9;
			c=0;
			for(int k=0;k<4;k++){if(pattern[10][data[k]]==1)c++;}
			if(c==4)return 10;
			c=0;
			for(int k=0;k<4;k++){if(pattern[11][data[k]]==1)c++;}
			if(c==4)return 11;
			c=0;
			for(int k=0;k<4;k++){if(pattern[12][data[k]]==1)c++;}
			if(c==4)return 12;
			c=0;
			for(int k=0;k<4;k++){if(pattern[13][data[k]]==1)c++;}
			if(c==4)return 13;
			c=0;
			for(int k=0;k<4;k++){if(pattern[14][data[k]]==1)c++;}
			if(c==4)return 14;
		}
		rotationY(data,sv,d);
		rotationX(data,sv,d);

		c=0;
		for(int k=0;k<4;k++){if(pattern[8][data[k]]==1)c++;}
		if(c==4)return 8;
		c=0;
		for(int k=0;k<4;k++){if(pattern[9][data[k]]==1)c++;}
		if(c==4)return 9;
		c=0;
		for(int k=0;k<4;k++){if(pattern[10][data[k]]==1)c++;}
		if(c==4)return 10;
		c=0;
		for(int k=0;k<4;k++){if(pattern[11][data[k]]==1)c++;}
		if(c==4)return 11;
		c=0;
		for(int k=0;k<4;k++){if(pattern[12][data[k]]==1)c++;}
		if(c==4)return 12;
		c=0;
		for(int k=0;k<4;k++){if(pattern[13][data[k]]==1)c++;}
		if(c==4)return 13;
		c=0;
		for(int k=0;k<4;k++){if(pattern[14][data[k]]==1)c++;}
		if(c==4)return 14;
	}
	return -1;
}

ogVector setMC(ogVector *sv, int *d, int value, int s, int t){
	double percentage;
	double bunbo;
	ogVector a1,a2;
	if(d[s]>d[t]){
		percentage=(double)(value-d[t]);
//		percentage=(double)(value-d[s]);
		bunbo=(double)(d[s]-d[t]);
		a1=sv[s] * percentage;
		a2=sv[t] * (bunbo-percentage);
		a1=a1+a2;
		a1=a1/bunbo;
		return a1;//percentage
//		return ( (sv[s] * percentage) + (sv[t] * (bunbo-percentage)) )/bunbo;//percentage
	}
	else{
		percentage=(double)(value-d[s]);
//		percentage=(double)(value-d[t]);
		bunbo=(double)(d[t]-d[s]);
		a1=sv[s]*(bunbo-percentage);
		a2=sv[t]*percentage;
		a1=a1+a2;
		a1=a1/bunbo;
		return a1;//percentage
//		return (sv[s]*(bunbo-percentage)+sv[t]*percentage)/bunbo;//percentage
	}
	a1=sv[s]*(bunbo-percentage);
	a2=sv[t]*percentage;
	a1=a1+a2;
	a1=a1/bunbo;
	return a1;//percentage
//	return (sv[s]*(bunbo-percentage)+sv[t]*percentage)/bunbo;//percentage
//	return (sv[s]*0.5+sv[t]*0.5);//percentage
}
/*
ogVector setMC(ogVector *sv, GLubyte *d, GLubyte value, int s, int t){
	double percentage;
	double bunbo;
	if(d[s]>d[t]){
		percentage=(double)(value-d[t]);
		bunbo=(double)(d[s]-d[t]);
	}
	else{
		percentage=(double)(value-d[s]);
		bunbo=(double)(d[t]-d[s]);
	}
	return (sv[s]*(bunbo-percentage)+sv[t]*percentage)/bunbo;//percentage
}
*/
/*
void rotation(int *data, int i, int j){
	for(;i>0;i--){
		for(;j<0;j--){
			rotationY(data,sv,d);
		}
		rotationX(data,sv,d);
	}
}*/
ogVector setNV(ogVector sv1, ogVector sv2, ogVector sv3){
	ogVector svn;
//	svn = (sv2-sv1)&(sv3-sv1);
	ogVector sv21,sv31;
	sv21=sv2-sv1;
	sv31=sv3-sv1;
	svn = sv21&sv31;
	svn.normalize();
	return svn;
}
