#pragma once
#include "glmfc/GLCall.h"
#include <stdio.h>
#include <locale.h>



void MyRender( void *p, float dt, int w, int h );
void MyInitRender( void *p );
void Colorset(double r, double b );
void ratioSet(int ratio );
float valueSet(int value );
int valueSet(float value );
void drawtypeSet(void *p, int type, System::Windows::Forms::ProgressBar * pb , int n, float max, float min);
void alphaSet(bool type );
void bondSet(bool type );
void sizeSet(int size );
void barSet(int x, int y, int z, int xy);
void mallocCube(int size);
int checkCube(void);
int loadCubeSet(char *filename, int num);
void observation_type(bool t);
float max_value(void);
float min_value(void);
void defaultsetting(void);

namespace mootic_win_v1_0
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::IO;
	using namespace System::Threading;


	/// <summary> 
	/// Form1 ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{
		bool bPause;
		int button;

	private: System::Windows::Forms::GroupBox *  groupBox2;
	private: System::Windows::Forms::RadioButton *  radioButton1;
	private: System::Windows::Forms::RadioButton *  radioButton2;
	private: System::Windows::Forms::RadioButton *  radioButton3;
	private: System::Windows::Forms::RadioButton *  radioButton4;
	private: System::Windows::Forms::RadioButton *  radioButton5;

	private: System::Windows::Forms::DomainUpDown *  domainUpDown1;
	private: System::Windows::Forms::ProgressBar *  progressBar1;
	private: System::Windows::Forms::HScrollBar *  hScrollBar1;
	private: System::Windows::Forms::HScrollBar *  hScrollBar2;
	private: System::Windows::Forms::RadioButton *  radioButton6;
	private: System::Windows::Forms::Label *  label1;
	private: System::Windows::Forms::Label *  label2;
	private: System::Windows::Forms::MenuItem *  menuItem3;
	private: System::Windows::Forms::GroupBox *  groupBox3;
	private: System::Windows::Forms::CheckBox *  checkBox1;
	private: System::Windows::Forms::NumericUpDown *  numericUpDown1;
	private: System::Windows::Forms::Label *  label3;
	private: System::Windows::Forms::HScrollBar *  hScrollBar3;
	private: System::Windows::Forms::VScrollBar *  vScrollBar1;
	private: System::Windows::Forms::Panel *  panel2;
	private: System::Windows::Forms::HScrollBar *  hScrollBar4;
	private: System::Windows::Forms::HScrollBar *  hScrollBar5;
	private: System::Windows::Forms::Label *  label4;
	private: System::Windows::Forms::Label *  label5;

	private: System::Windows::Forms::TabControl *  tabControl1;
	private: System::Windows::Forms::TabPage *  tabPage1;
	private: System::Windows::Forms::TabPage *  tabPage2;
	private: System::Windows::Forms::Label *  label6;
	private: System::Windows::Forms::NumericUpDown *  numericUpDown2;
	private: System::Windows::Forms::Label *  label7;
	private: System::Windows::Forms::Label *  label8;
	private: System::Windows::Forms::NumericUpDown *  numericUpDown3;
	private: System::Windows::Forms::NumericUpDown *  numericUpDown4;
	private: System::Windows::Forms::Button *  button1;
	private: System::Windows::Forms::Label *  label9;
	private: System::Windows::Forms::CheckBox *  checkBox2;
	private: System::Windows::Forms::Button *  button2;

	void *_pGL;
	void *_pGL2;

	public:
		Form1(void)
		{
			InitializeComponent();

			// OpenGL ̏
			_pGL = glcall::InitGL(pictureBox1->Handle);
			if(_pGL) MyInitRender(_pGL );

			_pGL2 = glcall::InitGL(pictureBox1->Handle);
			if(_pGL2) MyInitRender(_pGL2 );

		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			// OpenGL̊J
			glcall::DestroyGL( _pGL );

			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::Panel *  panel1;
	private: System::Windows::Forms::PictureBox *  pictureBox1;

	private: System::Windows::Forms::MainMenu *  mainMenu1;
	private: System::Windows::Forms::MenuItem *  menuItem1;
	private: System::Windows::Forms::MenuItem *  menuItem2;


	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container * components;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			System::Resources::ResourceManager *  resources = new System::Resources::ResourceManager(__typeof(mootic_win_v1_0::Form1));
			this->panel1 = new System::Windows::Forms::Panel();
			this->button2 = new System::Windows::Forms::Button();
			this->tabControl1 = new System::Windows::Forms::TabControl();
			this->tabPage1 = new System::Windows::Forms::TabPage();
			this->groupBox2 = new System::Windows::Forms::GroupBox();
			this->radioButton3 = new System::Windows::Forms::RadioButton();
			this->radioButton2 = new System::Windows::Forms::RadioButton();
			this->radioButton1 = new System::Windows::Forms::RadioButton();
			this->radioButton4 = new System::Windows::Forms::RadioButton();
			this->radioButton5 = new System::Windows::Forms::RadioButton();
			this->radioButton6 = new System::Windows::Forms::RadioButton();
			this->groupBox3 = new System::Windows::Forms::GroupBox();
			this->checkBox2 = new System::Windows::Forms::CheckBox();
			this->label9 = new System::Windows::Forms::Label();
			this->label3 = new System::Windows::Forms::Label();
			this->numericUpDown1 = new System::Windows::Forms::NumericUpDown();
			this->checkBox1 = new System::Windows::Forms::CheckBox();
			this->tabPage2 = new System::Windows::Forms::TabPage();
			this->button1 = new System::Windows::Forms::Button();
			this->numericUpDown4 = new System::Windows::Forms::NumericUpDown();
			this->numericUpDown3 = new System::Windows::Forms::NumericUpDown();
			this->label8 = new System::Windows::Forms::Label();
			this->label7 = new System::Windows::Forms::Label();
			this->numericUpDown2 = new System::Windows::Forms::NumericUpDown();
			this->label6 = new System::Windows::Forms::Label();
			this->label5 = new System::Windows::Forms::Label();
			this->label4 = new System::Windows::Forms::Label();
			this->hScrollBar5 = new System::Windows::Forms::HScrollBar();
			this->hScrollBar4 = new System::Windows::Forms::HScrollBar();
			this->label2 = new System::Windows::Forms::Label();
			this->label1 = new System::Windows::Forms::Label();
			this->hScrollBar2 = new System::Windows::Forms::HScrollBar();
			this->hScrollBar1 = new System::Windows::Forms::HScrollBar();
			this->progressBar1 = new System::Windows::Forms::ProgressBar();
			this->domainUpDown1 = new System::Windows::Forms::DomainUpDown();
			this->mainMenu1 = new System::Windows::Forms::MainMenu();
			this->menuItem1 = new System::Windows::Forms::MenuItem();
			this->menuItem2 = new System::Windows::Forms::MenuItem();
			this->menuItem3 = new System::Windows::Forms::MenuItem();
			this->hScrollBar3 = new System::Windows::Forms::HScrollBar();
			this->pictureBox1 = new System::Windows::Forms::PictureBox();
			this->panel2 = new System::Windows::Forms::Panel();
			this->vScrollBar1 = new System::Windows::Forms::VScrollBar();
			this->panel1->SuspendLayout();
			this->tabControl1->SuspendLayout();
			this->tabPage1->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->groupBox3->SuspendLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown1))->BeginInit();
			this->tabPage2->SuspendLayout();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown4))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown3))->BeginInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown2))->BeginInit();
			this->panel2->SuspendLayout();
			this->SuspendLayout();
			// 
			// panel1
			// 
			this->panel1->Controls->Add(this->button2);
			this->panel1->Controls->Add(this->tabControl1);
			this->panel1->Controls->Add(this->label5);
			this->panel1->Controls->Add(this->label4);
			this->panel1->Controls->Add(this->hScrollBar5);
			this->panel1->Controls->Add(this->hScrollBar4);
			this->panel1->Controls->Add(this->label2);
			this->panel1->Controls->Add(this->label1);
			this->panel1->Controls->Add(this->hScrollBar2);
			this->panel1->Controls->Add(this->hScrollBar1);
			this->panel1->Controls->Add(this->progressBar1);
			this->panel1->Controls->Add(this->domainUpDown1);
			this->panel1->Dock = System::Windows::Forms::DockStyle::Left;
			this->panel1->Location = System::Drawing::Point(0, 0);
			this->panel1->Name = S"panel1";
			this->panel1->Size = System::Drawing::Size(232, 496);
			this->panel1->TabIndex = 0;
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(144, 344);
			this->button2->Name = S"button2";
			this->button2->TabIndex = 15;
			this->button2->Text = S"̏";
			this->button2->Click += new System::EventHandler(this, button2_Click);
			// 
			// tabControl1
			// 
			this->tabControl1->Controls->Add(this->tabPage1);
			this->tabControl1->Controls->Add(this->tabPage2);
			this->tabControl1->Location = System::Drawing::Point(8, 8);
			this->tabControl1->Name = S"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(216, 240);
			this->tabControl1->TabIndex = 14;
			// 
			// tabPage1
			// 
			this->tabPage1->Controls->Add(this->groupBox2);
			this->tabPage1->Controls->Add(this->groupBox3);
			this->tabPage1->Location = System::Drawing::Point(4, 21);
			this->tabPage1->Name = S"tabPage1";
			this->tabPage1->Size = System::Drawing::Size(208, 215);
			this->tabPage1->TabIndex = 0;
			this->tabPage1->Text = S"{ݒ";
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->radioButton3);
			this->groupBox2->Controls->Add(this->radioButton2);
			this->groupBox2->Controls->Add(this->radioButton1);
			this->groupBox2->Controls->Add(this->radioButton4);
			this->groupBox2->Controls->Add(this->radioButton5);
			this->groupBox2->Controls->Add(this->radioButton6);
			this->groupBox2->Location = System::Drawing::Point(0, 8);
			this->groupBox2->Name = S"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(136, 208);
			this->groupBox2->TabIndex = 1;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = S"\[hI";
			// 
			// radioButton3
			// 
			this->radioButton3->Location = System::Drawing::Point(8, 80);
			this->radioButton3->Name = S"radioButton3";
			this->radioButton3->Size = System::Drawing::Size(112, 24);
			this->radioButton3->TabIndex = 2;
			this->radioButton3->Text = S"lʁi_j";
			this->radioButton3->CheckedChanged += new System::EventHandler(this, radioButton3_CheckedChanged);
			// 
			// radioButton2
			// 
			this->radioButton2->Location = System::Drawing::Point(8, 48);
			this->radioButton2->Name = S"radioButton2";
			this->radioButton2->Size = System::Drawing::Size(122, 24);
			this->radioButton2->TabIndex = 1;
			this->radioButton2->Text = S"dqzi_j";
			this->radioButton2->CheckedChanged += new System::EventHandler(this, radioButton2_CheckedChanged);
			// 
			// radioButton1
			// 
			this->radioButton1->Checked = true;
			this->radioButton1->Location = System::Drawing::Point(8, 16);
			this->radioButton1->Name = S"radioButton1";
			this->radioButton1->TabIndex = 0;
			this->radioButton1->TabStop = true;
			this->radioButton1->Text = S"qEî";
			this->radioButton1->CheckedChanged += new System::EventHandler(this, radioButton1_CheckedChanged);
			// 
			// radioButton4
			// 
			this->radioButton4->Location = System::Drawing::Point(8, 112);
			this->radioButton4->Name = S"radioButton4";
			this->radioButton4->Size = System::Drawing::Size(112, 24);
			this->radioButton4->TabIndex = 2;
			this->radioButton4->Text = S"lʁiʁj";
			this->radioButton4->CheckedChanged += new System::EventHandler(this, radioButton4_CheckedChanged);
			// 
			// radioButton5
			// 
			this->radioButton5->Location = System::Drawing::Point(8, 144);
			this->radioButton5->Name = S"radioButton5";
			this->radioButton5->Size = System::Drawing::Size(122, 24);
			this->radioButton5->TabIndex = 2;
			this->radioButton5->Text = S"lʁiWFj";
			this->radioButton5->CheckedChanged += new System::EventHandler(this, radioButton5_CheckedChanged);
			// 
			// radioButton6
			// 
			this->radioButton6->Location = System::Drawing::Point(8, 176);
			this->radioButton6->Name = S"radioButton6";
			this->radioButton6->Size = System::Drawing::Size(112, 24);
			this->radioButton6->TabIndex = 7;
			this->radioButton6->Text = S"lʁi_j";
			this->radioButton6->CheckedChanged += new System::EventHandler(this, radioButton6_CheckedChanged);
			// 
			// groupBox3
			// 
			this->groupBox3->Controls->Add(this->checkBox2);
			this->groupBox3->Controls->Add(this->label9);
			this->groupBox3->Controls->Add(this->label3);
			this->groupBox3->Controls->Add(this->numericUpDown1);
			this->groupBox3->Controls->Add(this->checkBox1);
			this->groupBox3->Location = System::Drawing::Point(136, 8);
			this->groupBox3->Name = S"groupBox3";
			this->groupBox3->Size = System::Drawing::Size(72, 208);
			this->groupBox3->TabIndex = 9;
			this->groupBox3->TabStop = false;
			this->groupBox3->Text = S"IvV";
			// 
			// checkBox2
			// 
			this->checkBox2->Checked = true;
			this->checkBox2->CheckState = System::Windows::Forms::CheckState::Checked;
			this->checkBox2->Location = System::Drawing::Point(8, 80);
			this->checkBox2->Name = S"checkBox2";
			this->checkBox2->Size = System::Drawing::Size(48, 24);
			this->checkBox2->TabIndex = 4;
			this->checkBox2->Text = S"\";
			this->checkBox2->CheckedChanged += new System::EventHandler(this, checkBox2_CheckedChanged);
			// 
			// label9
			// 
			this->label9->Location = System::Drawing::Point(8, 64);
			this->label9->Name = S"label9";
			this->label9->Size = System::Drawing::Size(60, 16);
			this->label9->TabIndex = 3;
			this->label9->Text = S"qEi";
			// 
			// label3
			// 
			this->label3->Location = System::Drawing::Point(8, 120);
			this->label3->Name = S"label3";
			this->label3->Size = System::Drawing::Size(56, 16);
			this->label3->TabIndex = 2;
			this->label3->Text = S"_TCY";
			// 
			// numericUpDown1
			// 
			this->numericUpDown1->Location = System::Drawing::Point(8, 144);
			System::Int32 __mcTemp__1[] = new System::Int32[4];
			__mcTemp__1[0] = 25;
			__mcTemp__1[1] = 0;
			__mcTemp__1[2] = 0;
			__mcTemp__1[3] = 0;
			this->numericUpDown1->Maximum = System::Decimal(__mcTemp__1);
			System::Int32 __mcTemp__2[] = new System::Int32[4];
			__mcTemp__2[0] = 1;
			__mcTemp__2[1] = 0;
			__mcTemp__2[2] = 0;
			__mcTemp__2[3] = 0;
			this->numericUpDown1->Minimum = System::Decimal(__mcTemp__2);
			this->numericUpDown1->Name = S"numericUpDown1";
			this->numericUpDown1->Size = System::Drawing::Size(56, 19);
			this->numericUpDown1->TabIndex = 1;
			System::Int32 __mcTemp__3[] = new System::Int32[4];
			__mcTemp__3[0] = 1;
			__mcTemp__3[1] = 0;
			__mcTemp__3[2] = 0;
			__mcTemp__3[3] = 0;
			this->numericUpDown1->Value = System::Decimal(__mcTemp__3);
			this->numericUpDown1->ValueChanged += new System::EventHandler(this, numericUpDown1_ValueChanged);
			// 
			// checkBox1
			// 
			this->checkBox1->Checked = true;
			this->checkBox1->CheckState = System::Windows::Forms::CheckState::Checked;
			this->checkBox1->Location = System::Drawing::Point(8, 16);
			this->checkBox1->Name = S"checkBox1";
			this->checkBox1->Size = System::Drawing::Size(56, 24);
			this->checkBox1->TabIndex = 0;
			this->checkBox1->Text = S"";
			this->checkBox1->CheckedChanged += new System::EventHandler(this, checkBox1_CheckedChanged);
			// 
			// tabPage2
			// 
			this->tabPage2->Controls->Add(this->button1);
			this->tabPage2->Controls->Add(this->numericUpDown4);
			this->tabPage2->Controls->Add(this->numericUpDown3);
			this->tabPage2->Controls->Add(this->label8);
			this->tabPage2->Controls->Add(this->label7);
			this->tabPage2->Controls->Add(this->numericUpDown2);
			this->tabPage2->Controls->Add(this->label6);
			this->tabPage2->Location = System::Drawing::Point(4, 21);
			this->tabPage2->Name = S"tabPage2";
			this->tabPage2->Size = System::Drawing::Size(208, 215);
			this->tabPage2->TabIndex = 1;
			this->tabPage2->Text = S"lʁi_jݒ";
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(64, 176);
			this->button1->Name = S"button1";
			this->button1->TabIndex = 6;
			this->button1->Text = S"č\z";
			this->button1->Click += new System::EventHandler(this, button1_Click);
			// 
			// numericUpDown4
			// 
			this->numericUpDown4->DecimalPlaces = 4;
			System::Int32 __mcTemp__4[] = new System::Int32[4];
			__mcTemp__4[0] = 1;
			__mcTemp__4[1] = 0;
			__mcTemp__4[2] = 0;
			__mcTemp__4[3] = 262144;
			this->numericUpDown4->Increment = System::Decimal(__mcTemp__4);
			this->numericUpDown4->Location = System::Drawing::Point(16, 136);
			System::Int32 __mcTemp__5[] = new System::Int32[4];
			__mcTemp__5[0] = 50;
			__mcTemp__5[1] = 0;
			__mcTemp__5[2] = 0;
			__mcTemp__5[3] = 65536;
			this->numericUpDown4->Maximum = System::Decimal(__mcTemp__5);
			System::Int32 __mcTemp__6[] = new System::Int32[4];
			__mcTemp__6[0] = 1;
			__mcTemp__6[1] = 0;
			__mcTemp__6[2] = 0;
			__mcTemp__6[3] = 262144;
			this->numericUpDown4->Minimum = System::Decimal(__mcTemp__6);
			this->numericUpDown4->Name = S"numericUpDown4";
			this->numericUpDown4->TabIndex = 5;
			System::Int32 __mcTemp__7[] = new System::Int32[4];
			__mcTemp__7[0] = 1;
			__mcTemp__7[1] = 0;
			__mcTemp__7[2] = 0;
			__mcTemp__7[3] = 262144;
			this->numericUpDown4->Value = System::Decimal(__mcTemp__7);
			// 
			// numericUpDown3
			// 
			this->numericUpDown3->DecimalPlaces = 4;
			System::Int32 __mcTemp__8[] = new System::Int32[4];
			__mcTemp__8[0] = 1;
			__mcTemp__8[1] = 0;
			__mcTemp__8[2] = 0;
			__mcTemp__8[3] = 262144;
			this->numericUpDown3->Increment = System::Decimal(__mcTemp__8);
			this->numericUpDown3->Location = System::Drawing::Point(16, 88);
			System::Int32 __mcTemp__9[] = new System::Int32[4];
			__mcTemp__9[0] = 50;
			__mcTemp__9[1] = 0;
			__mcTemp__9[2] = 0;
			__mcTemp__9[3] = 65536;
			this->numericUpDown3->Maximum = System::Decimal(__mcTemp__9);
			System::Int32 __mcTemp__10[] = new System::Int32[4];
			__mcTemp__10[0] = 1;
			__mcTemp__10[1] = 0;
			__mcTemp__10[2] = 0;
			__mcTemp__10[3] = 262144;
			this->numericUpDown3->Minimum = System::Decimal(__mcTemp__10);
			this->numericUpDown3->Name = S"numericUpDown3";
			this->numericUpDown3->TabIndex = 4;
			System::Int32 __mcTemp__11[] = new System::Int32[4];
			__mcTemp__11[0] = 1;
			__mcTemp__11[1] = 0;
			__mcTemp__11[2] = 0;
			__mcTemp__11[3] = 262144;
			this->numericUpDown3->Value = System::Decimal(__mcTemp__11);
			// 
			// label8
			// 
			this->label8->Location = System::Drawing::Point(8, 120);
			this->label8->Name = S"label8";
			this->label8->Size = System::Drawing::Size(96, 16);
			this->label8->TabIndex = 3;
			this->label8->Text = S"ŏl";
			// 
			// label7
			// 
			this->label7->Location = System::Drawing::Point(8, 72);
			this->label7->Name = S"label7";
			this->label7->Size = System::Drawing::Size(96, 16);
			this->label7->TabIndex = 2;
			this->label7->Text = S"ől";
			// 
			// numericUpDown2
			// 
			this->numericUpDown2->Location = System::Drawing::Point(16, 32);
			System::Int32 __mcTemp__12[] = new System::Int32[4];
			__mcTemp__12[0] = 255;
			__mcTemp__12[1] = 0;
			__mcTemp__12[2] = 0;
			__mcTemp__12[3] = 0;
			this->numericUpDown2->Maximum = System::Decimal(__mcTemp__12);
			System::Int32 __mcTemp__13[] = new System::Int32[4];
			__mcTemp__13[0] = 1;
			__mcTemp__13[1] = 0;
			__mcTemp__13[2] = 0;
			__mcTemp__13[3] = 0;
			this->numericUpDown2->Minimum = System::Decimal(__mcTemp__13);
			this->numericUpDown2->Name = S"numericUpDown2";
			this->numericUpDown2->TabIndex = 1;
			System::Int32 __mcTemp__14[] = new System::Int32[4];
			__mcTemp__14[0] = 8;
			__mcTemp__14[1] = 0;
			__mcTemp__14[2] = 0;
			__mcTemp__14[3] = 0;
			this->numericUpDown2->Value = System::Decimal(__mcTemp__14);
			// 
			// label6
			// 
			this->label6->Location = System::Drawing::Point(8, 8);
			this->label6->Name = S"label6";
			this->label6->Size = System::Drawing::Size(88, 16);
			this->label6->TabIndex = 0;
			this->label6->Text = S"";
			// 
			// label5
			// 
			this->label5->Location = System::Drawing::Point(16, 424);
			this->label5->Name = S"label5";
			this->label5->Size = System::Drawing::Size(200, 16);
			this->label5->TabIndex = 13;
			this->label5->Text = S"]izj";
			// 
			// label4
			// 
			this->label4->Location = System::Drawing::Point(16, 376);
			this->label4->Name = S"label4";
			this->label4->Size = System::Drawing::Size(200, 16);
			this->label4->TabIndex = 12;
			this->label4->Text = S"ZOOM/OUT";
			// 
			// hScrollBar5
			// 
			this->hScrollBar5->AllowDrop = true;
			this->hScrollBar5->Location = System::Drawing::Point(16, 440);
			this->hScrollBar5->Maximum = 720;
			this->hScrollBar5->Name = S"hScrollBar5";
			this->hScrollBar5->Size = System::Drawing::Size(200, 17);
			this->hScrollBar5->TabIndex = 11;
			this->hScrollBar5->Value = 360;
			this->hScrollBar5->Scroll += new System::Windows::Forms::ScrollEventHandler(this, hScrollBar5_Scroll);
			// 
			// hScrollBar4
			// 
			this->hScrollBar4->AllowDrop = true;
			this->hScrollBar4->Location = System::Drawing::Point(16, 392);
			this->hScrollBar4->Maximum = 80;
			this->hScrollBar4->Minimum = 5;
			this->hScrollBar4->Name = S"hScrollBar4";
			this->hScrollBar4->Size = System::Drawing::Size(200, 17);
			this->hScrollBar4->TabIndex = 10;
			this->hScrollBar4->Value = 50;
			this->hScrollBar4->Scroll += new System::Windows::Forms::ScrollEventHandler(this, hScrollBar4_Scroll);
			// 
			// label2
			// 
			this->label2->Location = System::Drawing::Point(16, 304);
			this->label2->Name = S"label2";
			this->label2->Size = System::Drawing::Size(200, 16);
			this->label2->TabIndex = 8;
			this->label2->Text = S"qOlݒ";
			// 
			// label1
			// 
			this->label1->Location = System::Drawing::Point(16, 264);
			this->label1->Name = S"label1";
			this->label1->RightToLeft = System::Windows::Forms::RightToLeft::No;
			this->label1->Size = System::Drawing::Size(200, 16);
			this->label1->TabIndex = 7;
			this->label1->Text = S"io[";
			// 
			// hScrollBar2
			// 
			this->hScrollBar2->AllowDrop = true;
			this->hScrollBar2->Location = System::Drawing::Point(16, 320);
			this->hScrollBar2->Maximum = 264;
			this->hScrollBar2->Name = S"hScrollBar2";
			this->hScrollBar2->Size = System::Drawing::Size(200, 16);
			this->hScrollBar2->TabIndex = 6;
			this->hScrollBar2->Value = 20;
			this->hScrollBar2->ValueChanged += new System::EventHandler(this, hScrollBar2_ValueChanged);
			this->hScrollBar2->Scroll += new System::Windows::Forms::ScrollEventHandler(this, hScrollBar2_Scroll);
			// 
			// hScrollBar1
			// 
			this->hScrollBar1->AllowDrop = true;
			this->hScrollBar1->CausesValidation = false;
			this->hScrollBar1->Location = System::Drawing::Point(16, 280);
			this->hScrollBar1->Maximum = 264;
			this->hScrollBar1->Name = S"hScrollBar1";
			this->hScrollBar1->Size = System::Drawing::Size(200, 16);
			this->hScrollBar1->TabIndex = 5;
			this->hScrollBar1->Value = 128;
			this->hScrollBar1->Scroll += new System::Windows::Forms::ScrollEventHandler(this, hScrollBar1_Scroll);
			// 
			// progressBar1
			// 
			this->progressBar1->Location = System::Drawing::Point(16, 472);
			this->progressBar1->Name = S"progressBar1";
			this->progressBar1->Size = System::Drawing::Size(200, 16);
			this->progressBar1->TabIndex = 4;
			// 
			// domainUpDown1
			// 
			this->domainUpDown1->AllowDrop = true;
			this->domainUpDown1->Location = System::Drawing::Point(16, 344);
			this->domainUpDown1->Name = S"domainUpDown1";
			this->domainUpDown1->Size = System::Drawing::Size(104, 19);
			this->domainUpDown1->TabIndex = 3;
			this->domainUpDown1->Text = S"lFړ";
			this->domainUpDown1->SelectedItemChanged += new System::EventHandler(this, domainUpDown1_SelectedItemChanged);
			// 
			// mainMenu1
			// 
			System::Windows::Forms::MenuItem* __mcTemp__15[] = new System::Windows::Forms::MenuItem*[1];
			__mcTemp__15[0] = this->menuItem1;
			this->mainMenu1->MenuItems->AddRange(__mcTemp__15);
			// 
			// menuItem1
			// 
			this->menuItem1->Index = 0;
			System::Windows::Forms::MenuItem* __mcTemp__16[] = new System::Windows::Forms::MenuItem*[2];
			__mcTemp__16[0] = this->menuItem2;
			__mcTemp__16[1] = this->menuItem3;
			this->menuItem1->MenuItems->AddRange(__mcTemp__16);
			this->menuItem1->Text = S"t@C";
			// 
			// menuItem2
			// 
			this->menuItem2->Index = 0;
			this->menuItem2->Text = S"J";
			this->menuItem2->Click += new System::EventHandler(this, menuItem2_Click);
			// 
			// menuItem3
			// 
			this->menuItem3->Index = 1;
			this->menuItem3->Text = S"I";
			this->menuItem3->Click += new System::EventHandler(this, menuItem3_Click);
			// 
			// hScrollBar3
			// 
			this->hScrollBar3->AllowDrop = true;
			this->hScrollBar3->CausesValidation = false;
			this->hScrollBar3->Dock = System::Windows::Forms::DockStyle::Bottom;
			this->hScrollBar3->Location = System::Drawing::Point(232, 480);
			this->hScrollBar3->Maximum = 720;
			this->hScrollBar3->Name = S"hScrollBar3";
			this->hScrollBar3->Size = System::Drawing::Size(480, 16);
			this->hScrollBar3->TabIndex = 2;
			this->hScrollBar3->Value = 360;
			this->hScrollBar3->Scroll += new System::Windows::Forms::ScrollEventHandler(this, hScrollBar3_Scroll);
			// 
			// pictureBox1
			// 
			this->pictureBox1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->pictureBox1->Location = System::Drawing::Point(232, 0);
			this->pictureBox1->Name = S"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(480, 480);
			this->pictureBox1->TabIndex = 1;
			this->pictureBox1->TabStop = false;
			this->pictureBox1->Paint += new System::Windows::Forms::PaintEventHandler(this, pictureBox1_Paint);
			// 
			// panel2
			// 
			this->panel2->Controls->Add(this->vScrollBar1);
			this->panel2->Dock = System::Windows::Forms::DockStyle::Right;
			this->panel2->Location = System::Drawing::Point(712, 0);
			this->panel2->Name = S"panel2";
			this->panel2->Size = System::Drawing::Size(16, 496);
			this->panel2->TabIndex = 4;
			// 
			// vScrollBar1
			// 
			this->vScrollBar1->AllowDrop = true;
			this->vScrollBar1->Anchor = (System::Windows::Forms::AnchorStyles)(System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom);
			this->vScrollBar1->CausesValidation = false;
			this->vScrollBar1->Location = System::Drawing::Point(0, 0);
			this->vScrollBar1->Maximum = 720;
			this->vScrollBar1->Name = S"vScrollBar1";
			this->vScrollBar1->Size = System::Drawing::Size(16, 480);
			this->vScrollBar1->TabIndex = 3;
			this->vScrollBar1->Value = 360;
			this->vScrollBar1->Scroll += new System::Windows::Forms::ScrollEventHandler(this, vScrollBar1_Scroll);
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(728, 496);
			this->Controls->Add(this->pictureBox1);
			this->Controls->Add(this->hScrollBar3);
			this->Controls->Add(this->panel1);
			this->Controls->Add(this->panel2);
			this->Icon = (__try_cast<System::Drawing::Icon *  >(resources->GetObject(S"$this.Icon")));
			this->Menu = this->mainMenu1;
			this->Name = S"Form1";
			this->Text = S"mootic v1.0";
			this->panel1->ResumeLayout(false);
			this->tabControl1->ResumeLayout(false);
			this->tabPage1->ResumeLayout(false);
			this->groupBox2->ResumeLayout(false);
			this->groupBox3->ResumeLayout(false);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown1))->EndInit();
			this->tabPage2->ResumeLayout(false);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown4))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown3))->EndInit();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->numericUpDown2))->EndInit();
			this->panel2->ResumeLayout(false);
			this->ResumeLayout(false);

		}	

private: System::Void pictureBox1_Paint(System::Object *  sender, System::Windows::Forms::PaintEventArgs *  e)
		 {
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }

private: System::Void menuItem3_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 exit(0);
		 }
private: System::Void menuItem2_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			OpenFileDialog* openFileDialog1 = new OpenFileDialog;
			int error=0;

			openFileDialog1->Filter = "Cubet@C(*.cube)|*.cube|bint@C(*.bin)|*.bin|Ή邷ׂẴt@C(*.cube, *.bin)|*.cube;*.bin";

			//^Cgݒ肷
			openFileDialog1->Title = "Jt@CIĂ";
			//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
			openFileDialog1->RestoreDirectory = true;
			//݂Ȃt@C̖Ow肳ꂽƂx\
			//ftHgTrueȂ̂Ŏw肷Kv͂Ȃ
			openFileDialog1->CheckFileExists = true;
			//݂ȂpXw肳ꂽƂx\
			//ftHgTrueȂ̂Ŏw肷Kv͂Ȃ
			openFileDialog1->CheckPathExists = true;
			openFileDialog1->Multiselect = true;

			if ( openFileDialog1->ShowDialog() == DialogResult::OK ){

				wchar_t wfn[200];
				

				int partition = (int)this->numericUpDown2->Value;
				progressBar1->Value = 0;

				if(openFileDialog1->FileNames->Length==1){
					observation_type(false);
					if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );

					mallocCube(partition);
					setlocale( LC_ALL, "Japanese" );
					for(int j=0;j<openFileDialog1->FileNames[0]->Length;j++){
						wfn[j] = openFileDialog1->FileNames[0]->get_Chars(j);
						if(wfn[j]=='\n')j--;
					}
					//wfn[j]='\0';
					wfn[openFileDialog1->FileNames[0]->Length]='\0';
					//fileǂݍ>>fn
					int nBufferLength = wcslen ( wfn );
					int nLength = wcstombs ( NULL, wfn, 0 );

					char *fn = new char[ nLength+1 ];
					memset ( fn, 0, nLength );
					wcstombs ( fn, wfn, nLength );fn[nLength]='\0';

					for(int i=0; i<partition; i++){
						error += loadCubeSet(fn, i);

						if(error != 0){
							printf("");
							exit(0);					
						}

						progressBar1->Value = 100*(i+1)/partition;
					}
				}

				else{
					observation_type(true);
					mallocCube(openFileDialog1->FileNames->Length);
					numericUpDown2->Value=openFileDialog1->FileNames->Length;
					setlocale( LC_ALL, "Japanese" );

					for(int i=0; i<openFileDialog1->FileNames->Length;i++){
						for(int j=0;j<openFileDialog1->FileNames[i]->Length;j++){
							wfn[j] = openFileDialog1->FileNames[i]->get_Chars(j);
							if(wfn[j]=='\n')j--;
						}

					//wfn[j]='\0';
						wfn[openFileDialog1->FileNames[i]->Length]='\0';
					//fileǂݍ>>fn
						int nBufferLength = wcslen ( wfn );
						int nLength = wcstombs ( NULL, wfn, 0 );

/*						Char fname[] = openFileDialog1->FileNames[i]->ToCharArray();
						int len = fname->Length;
						wchar_t *wfn2 = (wchar_t *)malloc(sizeof(wchar_t)*len);
						for(int cl=0; cl < len; cl++){wfn2[cl]=fname[cl];}
*/

						char *fn = new char[ nLength+1 ];

						memset ( fn, 0, nLength );
						wcstombs ( fn, wfn, nLength );
						fn[nLength]='\0';

						error += loadCubeSet(fn, i);

						if(error != 0){
							printf("");
							exit(0);
						}
						
						progressBar1->Value = int(((i+1)*100.0)/openFileDialog1->FileNames->Length);
					}
				}
				if(min_value()*min_value() > max_value()*max_value()) this->numericUpDown3->Value = -min_value();
				else this->numericUpDown3->Value = max_value();
			}

			if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }

private: System::Void domainUpDown1_SelectedItemChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			double v;
			char g[20];
			int vi;
			for(int i=0;i<domainUpDown1->Text->Length;i++){
				g[i] = char(domainUpDown1->Text->get_Chars(i));
			}
			g[i]='\0';
			v = atof(g);
			vi = valueSet(float(v));
			hScrollBar2->Value = vi;
			if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }
private: System::Void radioButton1_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(checkCube() && this->radioButton1->Checked){
				 MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				 return;
			 }

			 if(this->radioButton1->Checked==true){
				 drawtypeSet(_pGL,5,progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value, (float)this->numericUpDown4->Value);
				 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 }
		 }
private: System::Void radioButton2_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(checkCube() && this->radioButton2->Checked){
				 MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				 return;
			 }

			 if(this->radioButton2->Checked==true){
				 /*
				drawtypeSet(_pGL,0,progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
				if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
				*/

				ThreadStart *process = new ThreadStart( this, &Form1::ThreadMethod);
				Thread *newThread = new Thread( process );
				newThread->Start();

				if(this->_pGL) MyRender( this->_pGL, 0.0, this->pictureBox1->Width, this->pictureBox1->Height );

			 }
		 }

private: System::Void radioButton3_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(checkCube() && this->radioButton3->Checked){
				 MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				 return;
			 }

 			 if(this->radioButton3->Checked==true){
//				drawtypeSet(_pGL,1,progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
//				if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );

				ThreadStart *process = new ThreadStart( this, &Form1::ThreadMethod_i);
				Thread *newThread = new Thread( process );
				newThread->Start();

				if(this->_pGL) MyRender( this->_pGL, 0.0, this->pictureBox1->Width, this->pictureBox1->Height );
			 }
		 }

private: System::Void radioButton4_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(checkCube() && this->radioButton4->Checked){
				 MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				 return;
			 }

			 if(this->radioButton4->Checked==true){
				 drawtypeSet(_pGL,3,progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
				 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 }
		 }

private: System::Void radioButton5_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(checkCube() && this->radioButton5->Checked){
				 MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				 return;
			 }

			 if(this->radioButton5->Checked==true){
				 drawtypeSet(_pGL,4,progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
				 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 }
		 }

private: System::Void radioButton6_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(checkCube() && this->radioButton6->Checked){
				 MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				 return;
			 }

			 if(this->radioButton6->Checked==true){
				 drawtypeSet(_pGL,2,progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
				 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 }
		 }

private: System::Void checkBox1_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 alphaSet(checkBox1->Checked);
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }
private: System::Void checkBox2_CheckedChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 bondSet(checkBox2->Checked);
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }

private: System::Void numericUpDown1_ValueChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(checkCube()){
				MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
				return;
			}

			 sizeSet(int(numericUpDown1->Value));
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }

private: System::Void vScrollBar1_Scroll(System::Object *  sender, System::Windows::Forms::ScrollEventArgs *  e)
		 {
			 barSet(hScrollBar3->Value,vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 barSet(hScrollBar3->Value,vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
		 }

private: System::Void hScrollBar1_Scroll(System::Object *  sender, System::Windows::Forms::ScrollEventArgs *  e)
		 {
			int d = hScrollBar1->Value;
			ratioSet(d);
			if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );

		 }

private: System::Void hScrollBar2_Scroll(System::Object *  sender, System::Windows::Forms::ScrollEventArgs *  e)
		 {
			if(checkCube())return;
			char g[20];
			float vf;
			int d = hScrollBar2->Value;
			if(d==0)d=1;
			vf = valueSet(d);
			sprintf(g,"%f", vf);
			domainUpDown1->Text = g;
			if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }
private: System::Void hScrollBar2_ValueChanged(System::Object *  sender, System::EventArgs *  e)
		 {
			if(checkCube()){
				MessageBox::Show( "Of[^JĂ", "Of[^ǂݍł܂", MessageBoxButtons::OK, MessageBoxIcon::Exclamation );
				if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			}
		 }

private: System::Void hScrollBar3_Scroll(System::Object *  sender, System::Windows::Forms::ScrollEventArgs *  e)
		 {
			 barSet(hScrollBar3->Value,vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 barSet(hScrollBar3->Value,vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
		 }

private: System::Void hScrollBar4_Scroll(System::Object *  sender, System::Windows::Forms::ScrollEventArgs *  e)
		 {
			 barSet(hScrollBar3->Value, vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 barSet(hScrollBar3->Value,vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
		 }

private: System::Void hScrollBar5_Scroll(System::Object *  sender, System::Windows::Forms::ScrollEventArgs *  e)
		 {
			 barSet(hScrollBar3->Value, vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
			 barSet(hScrollBar3->Value,vScrollBar1->Value, hScrollBar4->Value, hScrollBar5->Value);
		 }

private: System::Void menuItem4_Click(System::Object *  sender, System::EventArgs *  e)
		 {

			

		 }

private: System::Void button1_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			 if(this->radioButton3->Checked == true){
				 drawtypeSet(_pGL,1,progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
			 }
			 if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }


private: System::Void button2_Click(System::Object *  sender, System::EventArgs *  e)
		 {
			defaultsetting();
			hScrollBar3->Value=360;
			vScrollBar1->Value=360;
			hScrollBar5->Value=360;
			hScrollBar4->Value=50;
			if(_pGL) MyRender( _pGL, 0.0, pictureBox1->Width, pictureBox1->Height );
		 }


public: void ThreadMethod(void)
   {
		drawtypeSet(this->_pGL2,0,this->progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
		void *_pGL3;
		_pGL3 = this->_pGL;
		this->_pGL=this->_pGL2;
		this->_pGL2=_pGL3;
		if(this->_pGL) MyRender( this->_pGL, 0.0, this->pictureBox1->Width, this->pictureBox1->Height );
   }
public: void ThreadMethod_i(void)
   {
		drawtypeSet(this->_pGL2,1,this->progressBar1, (int)this->numericUpDown2->Value, (float)this->numericUpDown3->Value,(float)this->numericUpDown4->Value);
		void *_pGL3;
		_pGL3 = this->_pGL;
		this->_pGL=this->_pGL2;
		this->_pGL2=_pGL3;
		if(this->_pGL) MyRender( this->_pGL, 0.0, this->pictureBox1->Width, this->pictureBox1->Height );
   }


};
}